#include<stdio.h>
#include<stdlib.h>
#include<math.h>
#include<time.h>
#define NUM_POINTS 13
void swap(int * a,int * b){										// function to swap values
	int temp = *a;												// creating a temporary variable and storing the value in it
	*a=*b;														// swapping value of b into a 
	*b=temp;													// swapping value of a from temp into a
}
int main(){
	srand(time(NULL));
	int p = rand()%1000;
	int i,j;
	int k;
	p = 16;
	double max_diff;
	double time[NUM_POINTS];
	int ita[NUM_POINTS];
	clock_t t;
	int tv = 0;
	int st;
	double eps = pow(10,-2);
	printf("No.of initial points = %d\nInput the number of clusters\n",p);
	scanf("%d",&k);
	while (p <= pow(2,16)){
		int q = p + 1;
		double dp[q][2];
		//printf("No.of initial points = %d\nInput the number of clusters\n",p);
		//scanf("%d",&k);
		t = clock();
		int l = k + 1;
		double cent[l][2];
		for (i = 1; i < p+1; i++){
			int r = rand()%1000000;
			dp[i][0] = (double)r/1000;
			r = rand()%1000000;
			dp[i][1] = (double)r/1000;
		}
		int m = 2;
		//scanf("%d",&m);
		int dfo[q];
		int po[q];
		float moc[q][k+1];
		for (i = 1; i < q; i++){
			int dist_sq = dp[i][0] * dp[i][0] + dp[i][1] * dp[i][1];
			int dist = sqrt(dist_sq);
			dfo[i] = dist;	
			po[i] = i;				
		}
		int ans;
		for (i = 1; i < q; i++){
			int min = dfo[i];
			ans = i;
			for (j = i; j < q; j++){
				if (min > dfo[j]){
					min = dfo[j];
					ans = j;
				}
			}
			swap(&dfo[i],&dfo[ans]);
			swap(&po[i],&po[ans]);
		}
		int jk = 0;	
		for (i = 1; i < l; i++){
			float x_coord = 0;
			float y_coord = 0;
			j = ((float)p)*i/k;
			//printf("\n%d %d\n",jk,j);
			int count = 0;
			for (int va = jk + 1; va <= j; va++){
				int point = po[va];
				x_coord += dp[point][0];
				y_coord += dp[point][1];
				count++;
				//printf("%d %d (%3.2lf,%3.2lf) %d\n",va,point,x_coord,y_coord,count);
			}
			cent[i][0] = x_coord/count;
			cent[i][1] = y_coord/count;
			//printf("(%lf,%lf)\n",cent[i][0],cent[i][1]);
			jk = ((float)p)*i/k;
			//printf("\n%d %d\n",jk,j);
		}
		double power = (float)1/(m-1);
		double dom[q][l];
		for (i = 1; i < q; i++){
			for (j = 1; j < l; j++){
				int r = rand()%100;
				dom[i][j] = (double)r/100;
				//dom[i][j] = 0;
			}
		} 
		int dv;
		int flag = 0;
		int count = 0;
		double diff;
		while (flag == 0){
			flag = 1;
			count++;
			max_diff = 0;
			for (i = 1; i < q; i++){
				for (j = 1; j < l; j++){
					double tdv;
					double x_coord = dp[i][0];
					double y_coord = dp[i][1];
					double x_diff1 = x_coord - cent[j][0];
					double y_diff1 = y_coord - cent[j][1];
					int dist_sq1 = (x_diff1)*(x_diff1) + (y_diff1)*(y_diff1);
					double dist1cwf = pow(dist_sq1,power);
					double sigma = 0;
					for (dv = 1; dv < l; dv++){
						double x_diff2 = x_coord - cent[dv][0];
						double y_diff2 = y_coord - cent[dv][1];
						int dist_sq2 = (x_diff2)*(x_diff2) + (y_diff2)*(y_diff2);
						double dist2cwf = pow(dist_sq2,power); 
						sigma += (double)dist1cwf/dist2cwf;
					}
					double dbc = (double)1/sigma;
					diff = dbc - dom[i][j];
					if (diff > max_diff) max_diff = diff;
					if (diff > eps) flag = 0;
					dom[i][j] = dbc;
				}
			}
			for (j = 1; j < l; j++){
				double x_coord = 0;
				double y_coord = 0;
				double som = 0;
				for (i = 1; i < q; i++){
					x_coord += dom[i][j] * dp[i][0];
					y_coord += dom[i][j] * dp[i][1];
					som += dom[i][j];
				}
				cent[j][0] = (double)x_coord/som;
				cent[j][1] = (double)y_coord/som;
			}
		}
		for (i = 1; i < q; i++){
			for (j = 1; j < l; j++){
				printf("%1.3lf ",dom[i][j]);
			}	
			printf("\n");
		}
		for (i = 1; i < l; i++){
			printf("cluster-%d centroid -> (%3.2lf,%3.2lf)\n",i,cent[i][0],cent[i][1]);
		}
		/*double modic[l];
		for (j = 1; j < l; j++){
			double sum = 0;
			for (i = 1; i < q; i++){
				double xcd = dp[i][0] - cent[j][0];
				double ycd = dp[i][1] - cent[j][1];
				int distbc_sq = ((xcd)*(xcd)) + ((ycd)*(ycd));
				int dist = sqrt(distbc_sq);
				dist *= dom[i][j];
				sum += dist;
			}
			modic[j] = sum/p;
		//	printf("modic in cluster -> %d = %lf\t",j,modic[i]);
		}
		//printf("value of dbindex = %lf\n",dbindex);
		//flag = 1;
		/*double val = pow(10,-9);
		for (i = 1; i < q; i++){
			double sum = 0;
			for (j = 1; j < l; j++){
				sum += dom[i][j];
			}
			if (sum - 1 >= val) {
				//printf("%d\t%lf\t%1.3lf\t%lf\terror!!!!\n",i,sum,sum-1,val);
				flag = 0;
			}
		}*/
		printf("Value of eps(sensitivity threshold) = %1.3lf\nNo.of clusters = %d\nNo.of points = %d\nNo.of iterations = %d\n",eps,k,p,count);
		//if (flag == 1) printf("success!!!\n");
		t = clock() - t;
		double tt = (double)t/CLOCKS_PER_SEC;
		time[tv] = tt;
		ita[tv] = count;
		//dbin[tv] = dbindex;
		tv++;
		p *= 2;
	}
	for (i = 0; i < NUM_POINTS; i++){
		printf("%lf\n",time[i]);
	}
	for (i = 0; i < NUM_POINTS; i++){
		printf("%d\n",ita[i]);
	}
	printf("\n");
	#define NUM_COMMANDS 2
	char * cfgp[] = {"set title \"time complexity of fuzzy c means\"","plot 'data.temp'with linespoints"};
	FILE * temp = fopen("data.temp","w");
	FILE * gnuplot = popen("gnuplot -persistent","w");
	int xval[NUM_POINTS];
	double yval[NUM_POINTS];
	for (i = 0; i < NUM_POINTS; i++){
		xval[i] = pow(2,i+4);
		yval[i] = time[i];
		fprintf(temp,"%d %lf\n",xval[i],yval[i]);
		//printf("")
	}
	for (i = 0; i < 2; i++){
		fprintf(gnuplot,"%s\n",cfgp[i]);
	}
	return 0;
}
