#include<stdio.h>
#include<stdlib.h>
#include<math.h>
#include<time.h>
#define NUM_POINTS 13
#define NUM_COMMANDS 2
void swap(int * a,int * b){										// function to swap values
	int temp = *a;												// creating a temporary variable and storing the value in it
	*a=*b;														// swapping value of b into a 
	*b=temp;													// swapping value of a from temp into a
}
int distfn(float xc1,float yc1,float xc2,float yc2){
		float xcd = xc1 - xc2;
		float ycd = yc1 - yc2;
		int dist_sq = (xcd)*(xcd) + (ycd)*(ycd);
		int dist = sqrt(dist_sq);
		return dist;
}
int main(){
	srand(time(NULL));
	int p,q,i,j;
	int qv;
	p = pow(2,4);
	double time[NUM_POINTS];
	int ic[NUM_POINTS];
	double di[NUM_POINTS];
	double dbiv[NUM_POINTS];
	int z = 0;
	clock_t t;
	int k;
	printf("Input the number of clusters : ");
	scanf("%d",&k); 									
	while (p <= pow(2,16)){
		printf("No.of data points = %d\n",p);
		q = p + 1;
		//k = 3;
		t = clock();
		int l = k + 1;
		int dm[l];
		float cent[l][2];
		int cm[l][q];
		float dp[q][2];
		for (i = 1; i < q; i++){
			int r = rand()%1000000;
			dp[i][0] = (float)(r)/1000;
			r = rand()%1000000;
			dp[i][1] = (float)(r)/1000;
		}
		int dfo[q];
		int po[q];
		for (i = 1; i < q; i++){
			int dist_sq = dp[i][0] * dp[i][0] + dp[i][1] * dp[i][1];
			int dist = sqrt(dist_sq);
			dfo[i] = dist;	
			po[i] = i;				
		}
		int ans;
		for (i = 1; i < q; i++){
			int min = dfo[i];
			ans = i;
			for (j = i; j < q; j++){
				if (min > dfo[j]){
					min = dfo[j];
					ans = j;
				}
			}
			swap(&dfo[i],&dfo[ans]);
			swap(&po[i],&po[ans]);
		}
		/*for (i = 1; i < q; i++){
			printf("%d %d\n",dfo[i],po[i]);
		}*/
		//printf("\n\ndistances sorted\n\n");
		//printf("%d\n",p);
		int jk = 0;	
		for (i = 1; i < l; i++){
			float x_coord = 0;
			float y_coord = 0;
			j = ((float)p)*i/k;
			//printf("\n%d %d\n",jk,j);
			int count = 0;
			for (int va = jk + 1; va <= j; va++){
				int point = po[va];
				x_coord += dp[point][0];
				y_coord += dp[point][1];
				count++;
				//printf("%d %d (%3.2lf,%3.2lf) %d\n",va,point,x_coord,y_coord,count);
			}
			cent[i][0] = x_coord/count;
			cent[i][1] = y_coord/count;
			//printf("(%lf,%lf)\n",cent[i][0],cent[i][1]);
			jk = ((float)p)*i/k;
			//printf("\n%d %d\n",jk,j);
		}
		for (i = 1; i < l; i++){
			//printf("(%3.2lf,%3.2lf)\t",cent[i][0],cent[i][1]);
		}
		printf("\n");
		//printf("\n\ninitial centroid points assigned\n\n");
		for (i = 1; i < l; i++){
			for (j = 0; j < q; j++){
				cm[i][j] = 0;
			}
		}
		for (i = 1; i < l; i++){
			//printf("(%3.2lf,%3.2lf)\t",cent[i][0],cent[i][1]);
		}
		printf("\n");
		for (i = 1; i < q; i++){
		//printf("entered main for loop(assigning points to clusters)\n");
			float x_coord = dp[i][0];
			float y_coord = dp[i][1];
			for (j = 1; j < l; j++){
				float xc_diff = x_coord - cent[j][0];
				float yc_diff = y_coord - cent[j][1];
				int dist_sq = ((xc_diff)*(xc_diff)) + ((yc_diff)*(yc_diff));
				int dist = sqrt(dist_sq);
				dm[j] = dist;
			}
			int min = dm[1];
			int ctbl = 1;
			for (j = 1; j < l; j++){
				if (min > dm[j]) {
					min = dm[j];
					ctbl = j;
				}
			}
			int nopic = cm[ctbl][0];
			cm[ctbl][nopic + 1] = i;
			cent[ctbl][0] = (nopic * cent[ctbl][0] + dp[i][0])/(nopic + 1);
			cent[ctbl][1] = (nopic * cent[ctbl][1] + dp[i][1])/(++nopic);
			cm[ctbl][0]++;
		}
		//printf("assigning points to clusters completed\n");
		int flag = 0;
		int count = 0;
		while (flag == 0){
			flag = 1;
			//printf("\t\t\t\t\t\t\t\t\t\tentered convergence loop %d\n",count);
			for (i = 1; i < l; i++){
				for (j = 1; j <= cm[i][0]; j++){
					int point = cm[i][j];
					float xc = dp[point][0];
					float yc = dp[point][1];
					int min = 2 * 1000000;
					int ans;
					int dtc;
					for (int w = 1; w < l; w++){
						float xc_dif = xc - cent[w][0];
						float yc_dif = yc - cent[w][1];
						int dist_sq = ((xc_dif) * (xc_dif)) + ((yc_dif) * (yc_dif)); 
						int dist = sqrt(dist_sq);
						if (w == i) dtc = dist;
						if (min > dist) {
							min = dist;
							ans = w;
						}
				 //printf("%d(%3.2lf,%3.2lf)(%3.2lf,%3.2lf)(%3.2lf,%3.2lf),%d,%d\n",point,xc,yc,cent[w][0],cent[w][1],xc_dif,yc_dif,dist,min);
					}
					if (dtc == min) ans = i;
					//printf("%d,%d %d %d %d %d",i,ans,j,cm[1][0],cm[2][0],cm[3][0]);
					if (ans != i){
						//printf("\t\t\t\t\t\t\t\t\t !!! error !!!");
						int val = cm[ans][0];
						cent[ans][0] = (cent[ans][0] * val + dp[point][0])/(val + 1);
						cent[ans][1] = (cent[ans][1] * val + dp[point][1])/(++val);
						cm[ans][0] = val;
						cm[ans][val] = point;
						val = cm[i][0];
						for (qv = j; qv < val; qv++){
							cm[i][qv] = cm[i][qv + 1];
						}
						int val2 = val - 1; 
						cent[i][0] = (cent[i][0] * val - dp[point][0])/(val2);
						cent[i][1] = (cent[i][1] * val - dp[point][1])/(val2);
						val--;
						cm[i][0] = val;
						cm[i][qv] = 0;
						flag  = 0;
					} 
				}
			}
			count++;	
		}
		int av;
		int maxd = 0;
		for (i = 1; i < l; i++){
			int md = 0;
			for (j = 1; j <= cm[i][0]; j++){
				for (av = j + 1; av <= cm[i][0]; av++){
					int p1 = cm[i][j];
					int p2 = cm[i][av];
					//int dist = distfn(dp[p1][0],dp[p1][1],dp[p2][0],dp[p2][1]);
					float xc1 = dp[p1][0];
					float xc2 = dp[p2][0];
					float yc1 = dp[p1][1];
					float yc2 = dp[p2][1];
					float xcd = xc1 - xc2;
					float ycd = yc1 - yc2;
					int dist_sq = ((xcd)*(xcd)) + ((ycd)*(ycd));
					int dist = sqrt(dist_sq);
					if (dist > md) md = dist;
				}
			}
			if (md > maxd) maxd = md;
		}
		int minn = 2*1000000;
		for (i = 1; i < l; i++){
			for (j = i + 1; j < l; j++){
				//int dist = distfn(cent[i][0],cent[i][1],cent[j][0],cent[j][1]);
				float xc1 = cent[i][0];
				float xc2 = cent[j][0];
				float yc1 = cent[i][1];
				float yc2 = cent[j][1];
				float xcd = xc1 - xc2;
				float ycd = yc1 - yc2;
				int dist_sq = (xcd)*(xcd) + (ycd)*(ycd);
				int dist = sqrt(dist_sq);
				if (dist < minn) minn = dist;
				//printf("minn = %d\t",minn); 
			}
		}
		printf("\n");
		double dunn_index = (double)minn/(double)maxd;
		double dbi[l][l];
		double modic[l];
		for (i = 1; i < l; i++){
			int sum = 0;
			for (j = 1; j <= cm[i][0]; j++){
				int p = cm[i][j];
				double xcd = dp[p][0] - cent[i][0];
				double ycd = dp[p][1] - cent[i][1];
				int dist_sq = ((xcd)*(xcd)) + ((ycd)*(ycd));
				int dist = sqrt(dist_sq);
				sum += dist;
			}
			double mean = (double)sum/cm[i][0];
			modic[i] = mean; 
		}
		for (i = 1; i < l; i++){
			dbi[i][i] = 0;
		}
		for (i = 1; i < l; i++){
			for (j = 1; j < i; j++){
				double xcd = cent[i][0] - cent[j][0];
				double ycd = cent[i][1] - cent[j][1];
				int dbc_sq = ((xcd)*(xcd)) + ((ycd)*(ycd));
				//int dbc = distfn(cent[i][0],cent[i][1],cent[j][0],cent[j][1]);
				int dbc = sqrt(dbc_sq);
				//printf("distance btw clusters %d %d = %d\n",i,j,dbc);
				dbi[i][j] = dbi[j][i] = (modic[i] + modic[j])/dbc;
			}
		}
		double mdbipc[l];
		double sumoi = 0;
		for (i = 1; i < l; i++){
			double mx = 0;
			for (j = 1; j < l; j++){
				if (dbi[i][j] > mx) mx = dbi[i][j];
			}
			//printf("mx value = %lf\n",mx);
			mdbipc[i] = mx;
			sumoi += mx;
		}
		double dbindex = sumoi/k;
		//printf("\nconveregence loop finished\n");
		//printf("%d %d\n",p,l);
		for (i = 1; i < l; i++){
			printf("%d\t\t(%3.2lf,%3.2lf)\n",cm[i][0],cent[i][0],cent[i][1]);
			for (j = 1; j <= cm[i][0]; j++){
				int point = cm[i][j];
				if (j != cm[i][0]) printf("%d(%3.2lf,%3.2lf),",point,dp[point][0],dp[point][1]);
				else printf("%d(%3.2lf,%3.2lf)|||\n\n",point,dp[point][0],dp[point][1]);
			}
		}
		int sum = 0;
		for (i = 1; i < l; i++){
			sum += cm[i][0];
			printf("%d\t",cm[i][0]);
		}
		//printf("\n%lf\t%lf\n",dbindex,sumoi);
		//printf("%lf\t%d\t%d",dunn_index,minn,maxd);
		if (sum == p) printf("\n\ndone here!!!\n\n");
		t = clock() - t;
		double tt = (double)t/CLOCKS_PER_SEC;
		time[z] = tt;
		ic[z] = count;
		di[z] = dunn_index;
		dbiv[z] = dbindex;
		z++;
		p *= 2;
	}
	/*for (z = 0; z < NUM_POINTS; z++){
		printf("%d\n",ic[z]);
	}
	for (z = 0;  z < NUM_POINTS; z++){
		printf("%lf\n",time[z]);
	}
	printf("\n");*/
	for (z = 0; z < NUM_POINTS; z++){
		printf("%lf\n",di[z]);
	}
	printf("\n");
	for (z = 0; z < NUM_POINTS; z++){
		printf("%lf\n",dbiv[z]);
	}
	printf("No.of clusters = %d\n",k);
	char * cfgp[] = {"set title \"time complexity of k means algo\"","plot 'kmc.temp' with linespoints"};
	double x_vals[NUM_POINTS];
	double y_vals[NUM_POINTS];
	FILE * temp = fopen("kmc.temp","w");
	FILE * gnuplot = popen("gnuplot -persistent","w");
	for (z = 0; z < NUM_POINTS; z++){
		x_vals[z] = pow(2,z+4);
		y_vals[z] = time[z];
		fprintf(temp,"%lf %lf\n",x_vals[z],y_vals[z]);
	}
	for (z = 0; z < NUM_COMMANDS; z++){
		fprintf(gnuplot,"%s\n", cfgp[z]);
	}
	return 0;
}
